<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>AuthChallengeProcessor xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/commons/httpclient/auth/AuthChallengeProcessor.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/auth/AuthChallengeProcessor.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../../org/apache/commons/httpclient/auth/package-summary.html">org.apache.commons.httpclient.auth</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> java.util.Collection;
<a name="34" href="#34">34</a>  <strong>import</strong> java.util.Iterator;
<a name="35" href="#35">35</a>  <strong>import</strong> java.util.Map;
<a name="36" href="#36">36</a>  
<a name="37" href="#37">37</a>  <strong>import</strong> org.apache.commons.httpclient.params.HttpParams;
<a name="38" href="#38">38</a>  <strong>import</strong> org.apache.commons.logging.Log;
<a name="39" href="#39">39</a>  <strong>import</strong> org.apache.commons.logging.LogFactory;
<a name="40" href="#40">40</a>  
<a name="41" href="#41">41</a>  <em>/**<em>*</em></em>
<a name="42" href="#42">42</a>  <em> * This class provides utility methods for processing HTTP www and proxy authentication </em>
<a name="43" href="#43">43</a>  <em> * challenges.</em>
<a name="44" href="#44">44</a>  <em> * </em>
<a name="45" href="#45">45</a>  <em> * @author &lt;a href="<a href="mailto:oleg@ural.ru" target="alexandria_uri">mailto:oleg@ural.ru</a>">Oleg Kalnichevski&lt;/a></em>
<a name="46" href="#46">46</a>  <em> * </em>
<a name="47" href="#47">47</a>  <em> * @since 3.0</em>
<a name="48" href="#48">48</a>  <em> */</em>
<a name="49" href="#49">49</a>  <strong>public</strong> <strong>final</strong> <strong>class</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthChallengeProcessor.html">AuthChallengeProcessor</a> {
<a name="50" href="#50">50</a>  
<a name="51" href="#51">51</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> Log LOG = LogFactory.getLog(AuthChallengeProcessor.<strong>class</strong>);
<a name="52" href="#52">52</a>  
<a name="53" href="#53">53</a>      <strong>private</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> params = <strong>null</strong>;
<a name="54" href="#54">54</a>      
<a name="55" href="#55">55</a>      <em>/**<em>*</em></em>
<a name="56" href="#56">56</a>  <em>     * Creates an authentication challenge processor with the given {@link HttpParams HTTP </em>
<a name="57" href="#57">57</a>  <em>     * parameters}</em>
<a name="58" href="#58">58</a>  <em>     * </em>
<a name="59" href="#59">59</a>  <em>     * @param params the {@link HttpParams HTTP parameters} used by this processor</em>
<a name="60" href="#60">60</a>  <em>     */</em>
<a name="61" href="#61">61</a>      <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthChallengeProcessor.html">AuthChallengeProcessor</a>(<strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> params) {
<a name="62" href="#62">62</a>          <strong>super</strong>();
<a name="63" href="#63">63</a>          <strong>if</strong> (params == <strong>null</strong>) {
<a name="64" href="#64">64</a>              <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Parameter collection may not be null"</span>);
<a name="65" href="#65">65</a>          }
<a name="66" href="#66">66</a>          <strong>this</strong>.params = params;
<a name="67" href="#67">67</a>      }
<a name="68" href="#68">68</a>  
<a name="69" href="#69">69</a>      <em>/**<em>*</em></em>
<a name="70" href="#70">70</a>  <em>     * Determines the preferred {@link AuthScheme authentication scheme} that can be used </em>
<a name="71" href="#71">71</a>  <em>     * to respond to the given collection of challenges.</em>
<a name="72" href="#72">72</a>  <em>     * </em>
<a name="73" href="#73">73</a>  <em>     * @param challenges the collection of authentication challenges</em>
<a name="74" href="#74">74</a>  <em>     * </em>
<a name="75" href="#75">75</a>  <em>     * @return the preferred {@link AuthScheme authentication scheme}</em>
<a name="76" href="#76">76</a>  <em>     * </em>
<a name="77" href="#77">77</a>  <em>     * @throws AuthChallengeException if the preferred authentication scheme </em>
<a name="78" href="#78">78</a>  <em>     * cannot be determined or is not supported</em>
<a name="79" href="#79">79</a>  <em>     */</em>
<a name="80" href="#80">80</a>      <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthScheme.html">AuthScheme</a> selectAuthScheme(<strong>final</strong> Map challenges) throws AuthChallengeException {
<a name="81" href="#81">81</a>          <strong>if</strong> (challenges == <strong>null</strong>) {
<a name="82" href="#82">82</a>              <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Challenge map may not be null"</span>); 
<a name="83" href="#83">83</a>          }
<a name="84" href="#84">84</a>          Collection authPrefs = (Collection) <strong>this</strong>.params.getParameter(
<a name="85" href="#85">85</a>              AuthPolicy.AUTH_SCHEME_PRIORITY);
<a name="86" href="#86">86</a>          <strong>if</strong> (authPrefs == <strong>null</strong> || authPrefs.isEmpty()) {
<a name="87" href="#87">87</a>              authPrefs = AuthPolicy.getDefaultAuthPrefs();    
<a name="88" href="#88">88</a>          }
<a name="89" href="#89">89</a>          <strong>if</strong> (LOG.isDebugEnabled()) {
<a name="90" href="#90">90</a>              LOG.debug(<span class="string">"Supported authentication schemes in the order of preference: "</span> 
<a name="91" href="#91">91</a>                  + authPrefs);
<a name="92" href="#92">92</a>          }
<a name="93" href="#93">93</a>          <a href="../../../../../org/apache/commons/httpclient/auth/AuthScheme.html">AuthScheme</a> authscheme = <strong>null</strong>;
<a name="94" href="#94">94</a>          String challenge = <strong>null</strong>;
<a name="95" href="#95">95</a>          Iterator item = authPrefs.iterator();
<a name="96" href="#96">96</a>          <strong>while</strong> (item.hasNext()) {
<a name="97" href="#97">97</a>              String id = (String) item.next();
<a name="98" href="#98">98</a>              challenge = (String) challenges.get(id.toLowerCase()); 
<a name="99" href="#99">99</a>              <strong>if</strong> (challenge != <strong>null</strong>) {
<a name="100" href="#100">100</a>                 <strong>if</strong> (LOG.isInfoEnabled()) {
<a name="101" href="#101">101</a>                     LOG.info(id + <span class="string">" authentication scheme selected"</span>);
<a name="102" href="#102">102</a>                 }
<a name="103" href="#103">103</a>                 <strong>try</strong> {
<a name="104" href="#104">104</a>                     authscheme = AuthPolicy.getAuthScheme(id);
<a name="105" href="#105">105</a>                 } <strong>catch</strong> (IllegalStateException e) {
<a name="106" href="#106">106</a>                     <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthChallengeException.html">AuthChallengeException</a>(e.getMessage());
<a name="107" href="#107">107</a>                 }
<a name="108" href="#108">108</a>                 <strong>break</strong>;
<a name="109" href="#109">109</a>             } <strong>else</strong> {
<a name="110" href="#110">110</a>                 <strong>if</strong> (LOG.isDebugEnabled()) {
<a name="111" href="#111">111</a>                     LOG.debug(<span class="string">"Challenge for "</span> + id + <span class="string">" authentication scheme not available"</span>);
<a name="112" href="#112">112</a>                     <em class="comment">// Try again</em>
<a name="113" href="#113">113</a>                 }
<a name="114" href="#114">114</a>             }
<a name="115" href="#115">115</a>         }
<a name="116" href="#116">116</a>         <strong>if</strong> (authscheme == <strong>null</strong>) {
<a name="117" href="#117">117</a>             <em class="comment">// If none selected, something is wrong</em>
<a name="118" href="#118">118</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthChallengeException.html">AuthChallengeException</a>(
<a name="119" href="#119">119</a>                 <span class="string">"Unable to respond to any of these challenges: "</span>
<a name="120" href="#120">120</a>                     + challenges);
<a name="121" href="#121">121</a>         }
<a name="122" href="#122">122</a>         <strong>return</strong> authscheme;
<a name="123" href="#123">123</a>     }
<a name="124" href="#124">124</a> 
<a name="125" href="#125">125</a>     <em>/**<em>*</em></em>
<a name="126" href="#126">126</a> <em>     * Processes the given collection of challenges and updates the </em>
<a name="127" href="#127">127</a> <em>     * {@link AuthState state} of the authentication process.</em>
<a name="128" href="#128">128</a> <em>     * </em>
<a name="129" href="#129">129</a> <em>     * @param challenges the collection of authentication challenges</em>
<a name="130" href="#130">130</a> <em>     * </em>
<a name="131" href="#131">131</a> <em>     * @return the {@link AuthScheme authentication scheme} used to </em>
<a name="132" href="#132">132</a> <em>     * process the challenge</em>
<a name="133" href="#133">133</a> <em>     * </em>
<a name="134" href="#134">134</a> <em>     * @throws AuthChallengeException if authentication challenges cannot be </em>
<a name="135" href="#135">135</a> <em>     * successfully processed or the preferred authentication scheme cannot</em>
<a name="136" href="#136">136</a> <em>     * be determined</em>
<a name="137" href="#137">137</a> <em>     */</em>
<a name="138" href="#138">138</a>     <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthScheme.html">AuthScheme</a> processChallenge(<strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthState.html">AuthState</a> state, <strong>final</strong> Map challenges)
<a name="139" href="#139">139</a>         throws MalformedChallengeException, <a href="../../../../../org/apache/commons/httpclient/auth/AuthenticationException.html">AuthenticationException</a>
<a name="140" href="#140">140</a>     {    
<a name="141" href="#141">141</a>         <strong>if</strong> (state == <strong>null</strong>) {
<a name="142" href="#142">142</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Authentication state may not be null"</span>); 
<a name="143" href="#143">143</a>         }
<a name="144" href="#144">144</a>         <strong>if</strong> (challenges == <strong>null</strong>) {
<a name="145" href="#145">145</a>             <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"Challenge map may not be null"</span>); 
<a name="146" href="#146">146</a>         }
<a name="147" href="#147">147</a>         
<a name="148" href="#148">148</a>         <strong>if</strong> (state.isPreemptive() || state.getAuthScheme() == <strong>null</strong>) {
<a name="149" href="#149">149</a>             <em class="comment">// Authentication not attempted before</em>
<a name="150" href="#150">150</a>             state.setAuthScheme(selectAuthScheme(challenges));
<a name="151" href="#151">151</a>         }
<a name="152" href="#152">152</a>         <a href="../../../../../org/apache/commons/httpclient/auth/AuthScheme.html">AuthScheme</a> authscheme = state.getAuthScheme();
<a name="153" href="#153">153</a>         String id = authscheme.getSchemeName();
<a name="154" href="#154">154</a>         <strong>if</strong> (LOG.isDebugEnabled()) {
<a name="155" href="#155">155</a>             LOG.debug(<span class="string">"Using authentication scheme: "</span> + id);
<a name="156" href="#156">156</a>         }
<a name="157" href="#157">157</a>         String challenge = (String) challenges.get(id.toLowerCase());
<a name="158" href="#158">158</a>         <strong>if</strong> (challenge == <strong>null</strong>) {
<a name="159" href="#159">159</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/auth/AuthenticationException.html">AuthenticationException</a>(id + 
<a name="160" href="#160">160</a>                 <span class="string">" authorization challenge expected, but not found"</span>);
<a name="161" href="#161">161</a>         }
<a name="162" href="#162">162</a>         authscheme.processChallenge(challenge);
<a name="163" href="#163">163</a>         LOG.debug(<span class="string">"Authorization challenge processed"</span>);
<a name="164" href="#164">164</a>         <strong>return</strong> authscheme;
<a name="165" href="#165">165</a>     }
<a name="166" href="#166">166</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

